package ErrorMsg;

public class ErrorMsg {
  private LineList linePos = new LineList(-1,null);
  private int lineNum=1;
  private String filename;
  public boolean anyErrors;

  public ErrorMsg(String f) { filename=f; }

  public void newline(int pos) {
     lineNum++;
     linePos = new LineList(pos,linePos);
  }

  public void error(int pos, String msg) {
	int n = lineNum;
        LineList p = linePos;
	String sayPos = "nowhere";

	anyErrors=true;

	for (; p != null && p.head > pos; p = p.tail, n--);

	if ( p!= null) sayPos = n + "." + (pos - p.head);

	System.out.println(filename + "::" + sayPos + ": " + msg);
  }
}
