package Translate;

public class Level {
    Level parent;
    protected Frame.Frame frame;
    public AccessList formals;

    public Level(Level p, Temp.Label name, Util.BoolList fmls) {
	parent = p;
	frame = parent.frame.newFrame(name,new Util.BoolList(true,fmls));
	formals = null;
	AccessList l = null;
	Frame.AccessList f = frame.formals.tail;

	for (; f != null; f = f.tail)
	    if (formals == null)
		formals = l = new AccessList(new Access(this,f.head),null);
	    else {
		l.tail = new AccessList(new Access(this,f.head),null);
		l = l.tail;
	    }
    }

    public Level(Frame.Frame f) {
	parent = null;
	frame = f;
	formals = null;
    }

    public Access allocLocal(boolean escape) {
	return new Access(this,frame.allocLocal(escape));
    }
}
