package Semant;

class VarEntry extends Entry {
    public Translate.Access access;
    public Types.Type ty;
    public boolean constant; // a constant cannot be explictly modified

    public VarEntry(Types.Type t) { ty = t; constant = false; access = null; }

    public VarEntry(Types.Type t,boolean c) {
	ty = t; constant = c; access = null;
    }

    public VarEntry(Translate.Access a,Types.Type t) {
	ty = t; constant = false; access = a;
    }

    public VarEntry(Translate.Access a,Types.Type t,boolean c) {
	ty =t; constant = c; access = a;
    }
}
